#ifndef _INCLUDE_SCROBJHOLDER_H_
#define _INCLUDE_SCROBJHOLDER_H_

/* 
Jumping Jack by Stanislav Tihohod 
Copyright (c) 2002 by Stanislav Tihohod. 
*/

//  CScreenObjectHolder    .      .
//     CScreenObjectHolder    .
//  CScreenObjectHolder    CDrawSurface     .
// Copyright (c) by Stanislav Tihohod, 2002

#include "ScrObject.h"

const int MaxScrObjUsed=32;

class CScreenObjectHolder
{
private:

	struct TLink
	{
		CScreenObject* m_pScreenObject;
		CScreenObjectHolder::TLink *m_pNextLink;
	};
	
	TLink *m_pUsedLinks;
	TLink *m_pCurrentUsedLink;
	TLink *m_pUnusedLinks;
	
	TLink m_Links[MaxScrObjUsed];
	
public:

	CScreenObjectHolder();

	CScreenObject* getFirstObject(void);
	CScreenObject* getNextObject(void);
	
	void addObject(CScreenObject *pNewObject);
	void deleteObject(CScreenObject *pDelObject);
	
private:

	void buidAllUnused(void);
	TLink *getUnused(void);
	void freeUsed(TLink *pUsedLink, TLink *pPrevLink);
};

#endif